<script setup lang="ts">
import { ref, watch, computed } from "vue";
import { useQuasar } from "quasar";

import { useCounterMixin } from "@/stores/mixin";
import { usePositionEmp } from "@/modules/16_positionEmployee/store/organizational";
import http from "@/plugins/http";
import config from "@/app.config";

/** importType*/
import type { QTableProps } from "quasar";
import type { HistoryPos } from "@/modules/16_positionEmployee/interface/response/organizational";

/** importComponents*/
import Header from "@/components/DialogHeader.vue";

/** use*/
const store = usePositionEmp();
const { showLoader, hideLoader, messageError, date2Thai } = useCounterMixin();
const $q = useQuasar();

/** props*/
const modal = defineModel<boolean>("modal", { required: true });
const props = defineProps({
  rowId: {
    type: String,
  },
  historyType: {
    type: String,
    default: "",
  },
});

const title = computed(() => {
  if (props.historyType === "HISTORY") return "ประวัติตำแหน่ง";
  if (props.historyType === "OWNER_HISTORY") return "ประวัติคนครอง";
  return "";
});

const rows = ref<HistoryPos[]>([]); //รายการแก้ไขประวัติ
const baseColumns = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "left",
    label: "ลำดับ",
    sortable: false,
    field: "no",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
  {
    name: "fullname",
    align: "left",
    label: "ชื่อคนครอง",
    sortable: true,
    field: "fullname",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "shortName",
    align: "left",
    label: "อักษรย่อ",
    sortable: true,
    field: "shortName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "posMasterNoPrefix",
    align: "left",
    label: " Prefix เลขที่ตำแหน่ง",
    sortable: true,
    field: "posMasterNoPrefix",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "posMasterNo",
    align: "left",
    label: "ตำแหน่งเลขที่",
    sortable: true,
    field: "posMasterNo",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a
        .toString()
        .localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "posMasterNoSuffix",
    align: "left",
    label: "Suffix เลขที่ตำแหน่ง",
    sortable: true,
    field: "posMasterNoSuffix",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "position",
    align: "left",
    label: "ตำแหน่ง",
    sortable: true,
    field: "position",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "posType",
    align: "left",
    label: "กลุ่มงาน",
    sortable: true,
    field: "posType",
    format(val, row) {
      let name = "";
      if (row.posType && row.position) {
        name = `${row.posType} (${row.posLevel})`;
      } else if (row.posType) {
        name = `${row.posType}`;
      } else if (row.posLevel) {
        name = `(${row.posLevel})`;
      } else name = "-";
      return name;
    },
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "lastUpdatedAt",
    align: "left",
    label: "วันที่แก้ไข",
    field: "lastUpdatedAt",
    sortable: false,
    format(val) {
      return date2Thai(val, true, true);
    },
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
  },
]);

const columns = computed(() =>
  props.historyType === "HISTORY"
    ? (baseColumns.value || []).filter((col: any) => col.name !== "fullname")
    : baseColumns.value || []
);

/**
 *  function เรียกข้อมูลประวัติตำแหน่ง
 * @param id
 */
function fetchHistoryPos(id: string) {
  showLoader();
  http
    .get(config.API.orgPosHistoryUpdateEmp(id))
    .then((res) => {
      const data: HistoryPos[] = res.data.result;
      rows.value =
        props.historyType === "HISTORY"
          ? formatHistoryData(data)
          : formatHistoryOwnerData(data);
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

function formatHistoryOwnerData(data: HistoryPos[]) {
  return data.map((item) => ({
    ...item,
    fullname: item.firstName
      ? `${item.prefix}${item.firstName} ${item.lastName}`.trim()
      : "ว่าง",
  }));
}

function formatHistoryData(data: HistoryPos[]) {
  return data.map((item) => ({
    ...item,
    shortName: item.orgShortName ?? "-",
  }));
}

/** callback function ทำงานเมื่อ   modal === true*/
watch(
  () => modal.value,
  () => {
    modal.value && props.rowId && fetchHistoryPos(props.rowId);
  }
);
</script>
<template>
  <q-dialog v-model="modal" persistent>
    <q-card style="min-width: 80%">
      <Header
        :tittle="title"
        :close="
          () => {
            modal = false;
          }
        "
      />
      <q-separator />

      <q-card-section class="q-pt-none q-pa-sm">
        <d-table
          flat
          bordered
          :rows="rows"
          :columns="columns"
          row-key="id"
          no-data-label="ไม่มีข้อมูล"
        >
          <template v-slot:header="props">
            <q-tr :props="props">
              <q-th v-for="col in props.cols" :key="col.name" :props="props">
                <span class="text-weight-medium">{{ col.label }}</span>
              </q-th>
            </q-tr>
          </template>
          <template v-slot:body="props">
            <q-tr :props="props" class="cursor-pointer">
              <q-td v-for="col in props.cols" :key="col.name" :props="props">
                <div v-if="col.name == 'no'">
                  {{
                    store.typeOrganizational === "current"
                      ? props.rowIndex + 1
                      : props.rowIndex + 1 == 1
                      ? "1 (แบบร่าง)"
                      : props.rowIndex + 1 == 2
                      ? "2 (ปัจจุบัน)"
                      : props.rowIndex + 1
                  }}
                </div>

                <div v-else>
                  {{ col.value ? col.value : "-" }}
                </div>
              </q-td>
            </q-tr>
          </template>
        </d-table>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<style scoped></style>
